/******************************/
/*  Testbench for Code 15.19  */
/******************************/
module tb_add_8b ;

    parameter    N = 8;
    reg  [N-1:0] a, b;
    wire [N-1:0] sum;
    wire	 cout;
    integer      j, k;

    add_8b U0_8b_adder (.a(a), .b(b), .sum(sum), .cout(cout));
   
    initial begin  
      forever begin
         for (j = 0; j < 256; j = j+1)
         begin
           a[7] = j/128;
           a[6] = (j%128)/64;
           a[5] = (j%64)/32;
           a[4] = (j%32)/16;
           a[3] = (j%16)/8;
           a[2] = (j%8)/4;
           a[1] = (j%4)/2;
           a[0] = j%2;
        
           for (k = 0; k < 256; k = k+1)
           begin
             b[7] = k/128;
             b[6] = (k%128)/64;
             b[5] = (k%64)/32;
             b[4] = (k%32)/16;
             b[3] = (k%16)/8;
             b[2] = (k%8)/4;
             b[1] = (k%4)/2;
             b[0] = k%2;
             #10;
           end    //End of for-loop-1
         end      //End of for-loop-2
      end         //End of forever
    end           //End of initial 
          
endmodule