/*****************************/
/*       Code 15.17          */
/*****************************/
module add_Nb (a, b, cin, sum, cout);
    parameter      N = 1;

    input  [N-1:0] a, b;
    input          cin;

    output [N-1:0] sum;
    output         cout;

    reg    [N-1:0] sum, p;
    reg    [N:0]   carry;
    integer        i;
    
  always @(a or b or cin)  begin
    carry[0] = cin;
    
    for (i=0; i<N; i=i+1) begin
        p[i] = (a[i] ^ b[i]);
        sum[i] = (p[i] ^ carry[i]);
      
        case (p[i])                 
             0     : carry[i+1] = a[i];        
           default : carry[i+1] = carry[i];        
        endcase
    end
  end
  
  assign cout = carry[N];
  
endmodule