/*****************************/
/*       Code 15.30          */
/*****************************/
module enc_16to4_en (enc_in, enable, enc_out);
                                              
   input  [15:0] enc_in;                      
   input          enable;                     
   output [3:0]  enc_out;
   reg	  [3:0]  enc_out;
   
  always @(enable or enc_in) begin
   	if (enable) enc_out = 4'b0000;
   	else begin
   		case (enc_in)
   			16'h0001 : enc_out = 0;
   			16'h0002 : enc_out = 1;
   			16'h0004 : enc_out = 2;
   			16'h0008 : enc_out = 3;
   			16'h0010 : enc_out = 4;
   			16'h0020 : enc_out = 5;
   			16'h0040 : enc_out = 6;
   			16'h0080 : enc_out = 7;
   			16'h0100 : enc_out = 8;
   			16'h0200 : enc_out = 9;
   			16'h0400 : enc_out = 10;
   			16'h0800 : enc_out = 11;
   			16'h1000 : enc_out = 12;
   			16'h2000 : enc_out = 13;
   			16'h4000 : enc_out = 14;
   			16'h8000 : enc_out = 15;
   			default : enc_out = 0;
   		endcase
   	end
   end

endmodule