/*****************************/
/*       Code 15.37          */
/*****************************/
module alu_4b(op_a, op_b, inst, alu_out);

	input	[3:0] op_a, op_b;
	input	[3:0] inst;
	output[3:0] alu_out;
	reg	  [3:0] logic_out, arith_out, alu_out;

	always @(inst or op_a or op_b)	begin
	    case (inst[2:1])  // Logic Unit
	      2'b00  : logic_out = 0;
	      2'b01  : logic_out = op_a & op_b;
	      2'b10  : logic_out = op_a | op_b;
	      2'b11  : logic_out = op_a ^ op_b;
	    endcase

	    case (inst[2:0]) // Arithmetic Unit    
	      3'b000  : arith_out =   op_a;
	      3'b001  : arith_out =  ~op_a;
	      3'b010  : arith_out =   op_a + 1;
	      3'b011  : arith_out =   op_a - 1;
	      3'b100  : arith_out =   op_a + op_b;
	      3'b101  : arith_out =   op_a - op_b;
	      default : arith_out = 0;
	    endcase

	    case (inst[3])
	      1'b0 : if (inst[0])
	                alu_out = ~logic_out;
	             else 
	                alu_out = logic_out;
	      1'b1 : alu_out = arith_out;
	    endcase
	end
		 	
endmodule     